Merge pull request #2338 from BogdanovKirill/httpwritefix3
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = assemblyresolve gc-descriptors
2
3 check-local: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test-cattr-type-load test-reflection-load-with-context test_platform test-process-exit test-messages test-env-options test-unhandled-exception-2 test-appdomain-unload rm-empty-logs
4 check-full: test-sgen check-local
5 check-parallel: compile-tests check-full
6
7 check-coreclr:
8         $(MAKE) -C $(mono_build_root)/acceptance-tests check-coreclr
9
10 # for backwards compatibility on Wrench
11 test-wrench: check-parallel
12
13 aotcheck: testaot gshared-aot
14
15 TEST_PROG = ../interpreter/mint
16
17 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
18
19 TEST_PROG_RUN = MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
20 JITTEST_PROG_RUN = MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
21
22 RUNTIME_ARGS=--config tests-config --optimize=all --debug
23
24 CLASS=$(mcs_topdir)/class/lib/$(DEFAULT_PROFILE)
25
26 with_mono_path = MONO_PATH=$(CLASS)
27
28 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
29
30 MKBUNDLE = \
31         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
32         $(RUNTIME) $(CLASS)/mkbundle.exe
33
34 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -debug \
35         -nowarn:0162 -nowarn:0168 -nowarn:0219 -nowarn:0414 -nowarn:0618 \
36         -nowarn:0169 -nowarn:1690 -nowarn:0649 -nowarn:0612 -nowarn:3021 \
37         -nowarn:0197
38 ILASM = $(RUNTIME) $(CLASS)/ilasm.exe
39
40 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
41
42 STRESS_TESTS_SRC=       \
43         abort-stress-1.cs       \
44         abort-stress-2.cs       \
45         abort-stress-3.cs       \
46         domain-stress.cs        \
47         gchandle-stress.cs      \
48         monitor-stress.cs       \
49         thread-stress.cs        \
50         gc-stress.cs            \
51         gc-copy-stress.cs       \
52         gc-graystack-stress.cs          \
53         exit-stress.cs          \
54         process-stress.cs       \
55         assembly-load-stress.cs
56
57 # Disabled until ?mcs is fixed
58 #       bug-331958.cs
59 BASE_TEST_CS_SRC=               \
60         bug-2907.cs             \
61         array-init.cs           \
62         arraylist.cs            \
63         assemblyresolve_event.cs        \
64         assemblyresolve_event3.cs       \
65         assemblyresolve_event4.cs       \
66         checked.cs              \
67         char-isnumber.cs        \
68         create-instance.cs      \
69         field-layout.cs         \
70         pack-layout.cs          \
71         pack-bug.cs             \
72         hash-table.cs           \
73         test-ops.cs             \
74         obj.cs                  \
75         test-dup-mp.cs          \
76         string.cs               \
77         stringbuilder.cs        \
78         switch.cs               \
79         outparm.cs              \
80         delegate.cs             \
81         bitconverter.cs         \
82         exception.cs            \
83         exception2.cs           \
84         exception3.cs           \
85         exception4.cs           \
86         exception5.cs           \
87         exception6.cs           \
88         exception7.cs           \
89         exception8.cs           \
90         exception10.cs          \
91         exception11.cs          \
92         exception12.cs          \
93         exception13.cs          \
94         exception14.cs          \
95         exception15.cs          \
96         exception16.cs          \
97         exception17.cs          \
98         exception18.cs          \
99         typeload-unaligned.cs   \
100         struct.cs               \
101         valuetype-gettype.cs    \
102         typeof-ptr.cs           \
103         static-constructor.cs   \
104         pinvoke.cs              \
105         pinvoke2.cs             \
106         pinvoke3.cs             \
107         pinvoke11.cs            \
108         pinvoke13.cs            \
109         pinvoke17.cs            \
110         invoke.cs               \
111         invoke2.cs              \
112         runtime-invoke.cs               \
113         invoke-string-ctors.cs          \
114         reinit.cs               \
115         box.cs                  \
116         array.cs                \
117         enum.cs                 \
118         enum2.cs                \
119         enum-intrins.cs         \
120         property.cs             \
121         enumcast.cs             \
122         assignable-tests.cs     \
123         array-cast.cs           \
124         array-subtype-attr.cs   \
125         cattr-compile.cs        \
126         cattr-field.cs          \
127         cattr-object.cs         \
128         custom-attr.cs          \
129         double-cast.cs          \
130         newobj-valuetype.cs     \
131         arraylist-clone.cs      \
132         setenv.cs               \
133         vtype.cs                \
134         isvaluetype.cs          \
135         iface6.cs               \
136         iface7.cs               \
137         ipaddress.cs            \
138         array-vt.cs             \
139         interface1.cs           \
140         reflection-enum.cs      \
141         reflection-prop.cs      \
142         reflection4.cs          \
143         reflection5.cs          \
144         reflection-const-field.cs \
145         many-locals.cs          \
146         string-compare.cs       \
147         test-prime.cs           \
148         test-tls.cs             \
149         params.cs               \
150         reflection.cs           \
151         interface.cs            \
152         iface.cs                \
153         iface2.cs               \
154         iface3.cs               \
155         iface4.cs               \
156         iface-large.cs          \
157         virtual-method.cs       \
158         intptrcast.cs           \
159         indexer.cs              \
160         stream.cs               \
161         console.cs              \
162         shift.cs                \
163         jit-int.cs              \
164         jit-uint.cs             \
165         jit-long.cs             \
166         long.cs                 \
167         jit-ulong.cs            \
168         jit-float.cs            \
169         pop.cs                  \
170         time.cs                 \
171         appdomain.cs        \
172         appdomain1.cs           \
173         appdomain2.cs           \
174         appdomain-client.cs     \
175         appdomain-unload.cs \
176         appdomain-async-invoke.cs       \
177         loader.cs       \
178         pointer.cs              \
179         hashcode.cs             \
180         delegate1.cs            \
181         delegate2.cs            \
182         delegate3.cs            \
183         delegate5.cs            \
184         delegate6.cs            \
185         delegate7.cs            \
186         delegate8.cs            \
187         delegate9.cs            \
188         delegate10.cs           \
189         delegate11.cs           \
190         delegate12.cs           \
191         delegate13.cs           \
192         remoting1.cs            \
193         remoting2.cs            \
194         remoting3.cs            \
195         remoting4.cs            \
196         remoting5.cs            \
197         largeexp.cs             \
198         largeexp2.cs            \
199         marshalbyref1.cs        \
200         static-ctor.cs          \
201         inctest.cs              \
202         bound.cs                \
203         array-invoke.cs         \
204         test-arr.cs             \
205         decimal.cs              \
206         decimal-array.cs        \
207         marshal.cs              \
208         marshal1.cs             \
209         marshal2.cs             \
210         marshal3.cs             \
211         marshal5.cs             \
212         marshal6.cs             \
213         marshal7.cs             \
214         marshal8.cs             \
215         marshal9.cs             \
216         marshalbool.cs          \
217         marshal-valuetypes.cs   \
218         test-byval-in-struct.cs \
219         thread.cs               \
220         thread5.cs              \
221         thread6.cs              \
222         thread-static.cs        \
223         thread-static-init.cs   \
224         context-static.cs       \
225         float-pop.cs            \
226         interfacecast.cs        \
227         array3.cs               \
228         classinit.cs            \
229         classinit2.cs           \
230         classinit3.cs           \
231         synchronized.cs         \
232         async_read.cs           \
233         threadpool.cs           \
234         threadpool1.cs          \
235         threadpool-exceptions1.cs \
236         threadpool-exceptions2.cs \
237         threadpool-exceptions3.cs \
238         threadpool-exceptions4.cs \
239         threadpool-exceptions5.cs \
240         threadpool-exceptions6.cs \
241         threadpool-exceptions7.cs \
242         base-definition.cs      \
243         bug-27420.cs            \
244         bug-47295.cs            \
245         bug-46781.cs            \
246         bug-48015.cs            \
247         bug-42136.cs            \
248         bug-59286.cs            \
249         bug-70561.cs            \
250         bug-78311.cs            \
251         bug-78653.cs            \
252         bug-78656.cs            \
253         bug-77127.cs            \
254         bug-323114.cs           \
255         bug-Xamarin-5278.cs     \
256         interlocked.cs          \
257         cross-domain.cs         \
258         appdomain-exit.cs       \
259         delegate-async-exit.cs  \
260         delegate-delegate-exit.cs       \
261         delegate-exit.cs        \
262         finalizer-abort.cs      \
263         finalizer-exception.cs  \
264         finalizer-exit.cs       \
265         finalizer-thread.cs     \
266         main-exit.cs    \
267         main-returns-abort-resetabort.cs        \
268         main-returns-background-abort-resetabort.cs     \
269         main-returns-background-resetabort.cs   \
270         main-returns-background.cs      \
271         main-returns-background-change.cs       \
272         main-returns.cs         \
273         subthread-exit.cs       \
274         desweak.cs              \
275         cominterop.cs           \
276         exists.cs               \
277         handleref.cs    \
278         transparentproxy.cs \
279         dbnull-missing.cs       \
280         test-type-ctor.cs       \
281         soft-float-tests.cs     \
282         thread-exit.cs          \
283         finalize-parent.cs      \
284         assemblyresolve_event2.2.cs     \
285         interlocked-2.2.cs      \
286         pinvoke-2.2.cs          \
287         bug-78431.2.cs          \
288         bug-79684.2.cs          \
289         catch-generics.2.cs     \
290         event-get.2.cs          \
291         safehandle.2.cs         \
292         stackframes-async.2.cs          \
293         module-cctor-loader.2.cs        \
294         generics-invoke-byref.2.cs      \
295         generic-signature-compare.2.cs  \
296         generics-sharing.2.cs   \
297         shared-generic-methods.2.cs     \
298         shared-generic-synchronized.2.cs        \
299         generic-inlining.2.cs   \
300         generic-initobj.2.cs    \
301         generic-delegate.2.cs   \
302         generic-sizeof.2.cs     \
303         generic-virtual.2.cs    \
304         generic-interface-methods.2.cs  \
305         generic-array-type.2.cs \
306         generic-method-patching.2.cs    \
307         generic-static-methods.2.cs     \
308         generic-null-call.2.cs  \
309         generic-special.2.cs    \
310         generic-exceptions.2.cs \
311         generic-virtual2.2.cs   \
312         generic-valuetype-interface.2.cs        \
313         generic-getgenericarguments.2.cs        \
314         generic-type-builder.2.cs       \
315         generic-synchronized.2.cs       \
316         generic-delegate-ctor.2.cs      \
317         generic-array-iface-set.2.cs    \
318         generic-typedef.2.cs    \
319         generic-marshalbyref.2.cs       \
320         generic-xdomain.2.cs    \
321         dynamic-generic-size.cs \
322         bug-431413.2.cs \
323         bug-459285.2.cs \
324         generic-virtual-invoke.2.cs     \
325         bug-461198.2.cs \
326         generic-sealed-virtual.2.cs     \
327         generic-system-arrays.2.cs      \
328         generic-stack-traces.2.cs       \
329         generic-stack-traces2.2.cs      \
330         bug-472600.2.cs \
331         recursive-generics.2.cs \
332         bug-473482.2.cs \
333         bug-473999.2.cs \
334         bug-479763.2.cs \
335         bug-616463.cs   \
336         bug-80392.2.cs          \
337         dynamic-method-access.2.cs      \
338         dynamic-method-finalize.2.cs    \
339         dynamic-method-stack-traces.cs  \
340         bug-82194.2.cs  \
341         anonarray.2.cs  \
342         ienumerator-interfaces.2.cs     \
343         array-enumerator-ifaces.2.cs    \
344         generic_type_definition_encoding.2.cs \
345         generic_type_definition.2.cs    \
346         bug-333798.2.cs         \
347         bug-333798-tb.2.cs              \
348         bug-335131.2.cs         \
349         bug-322722_patch_bx.2.cs                \
350         bug-348522.2.cs         \
351         bug-340662_bug.cs       \
352         bug-322722_dyn_method_throw.2.cs        \
353         bug-389886-2.cs \
354         bug-325283.2.cs \
355         thunks.cs \
356         winx64structs.cs \
357         bug-349190.2.cs \
358         nullable_boxing.2.cs    \
359         valuetype-equals.cs     \
360         custom-modifiers.2.cs   \
361         bug-382986.cs   \
362         test-inline-call-stack.cs       \
363         bug-324535.cs   \
364         modules.cs      \
365         bug-81673.cs    \
366         bug-81691.cs    \
367         bug-80307.cs    \
368         bug-415577.cs   \
369         filter-stack.cs \
370         vararg2.cs      \
371         bug-389886-sre-generic-interface-instances.cs   \
372         bug-461867.cs   \
373         bug-461941.cs   \
374         bug-461261.cs   \
375         bug-400716.cs   \
376         bug-462592.cs   \
377         bug-459094.cs   \
378         generic-unloading.2.cs  \
379         generic-unloading-sub.2.cs      \
380         bug-467456.cs   \
381         appdomain-unload-callback.cs    \
382         bug-508538.cs   \
383         bug-472692.2.cs         \
384         gchandles.cs    \
385         interlocked-3.cs        \
386         interlocked-4.2.cs      \
387         appdomain-thread-abort.cs \
388         xdomain-threads.cs      \
389         w32message.cs   \
390         bug-544446.cs   \
391         gc-altstack.cs  \
392         large-gc-bitmap.cs      \
393         bug-561239.cs   \
394         bug-562150.cs   \
395         bug-575941.cs   \
396         bug-599469.cs   \
397         bug-389886-3.cs \
398         monitor.cs      \
399         monitor-resurrection.cs \
400         dynamic-method-resurrection.cs  \
401         bug-666008.cs   \
402         bug-685908.cs   \
403         sgen-long-vtype.cs      \
404         delegate-invoke.cs      \
405         bug-696593.cs   \
406         bug-705140.cs   \
407         bug-1147.cs     \
408         mono-path.cs    \
409         bug-bxc-795.cs  \
410         bug-3903.cs     \
411         async-with-cb-throws.cs \
412         appdomain-unload-doesnot-raise-pending-events.cs        \
413         bug-6148.cs     \
414         assembly_append_ordering.cs     \
415         bug-10127.cs    \
416         bug-18026.cs    \
417         allow-synchronous-major.cs      \
418         unload-appdomain-on-shutdown.cs \
419         block_guard_restore_aligment_on_exit.cs \
420         thread_static_gc_layout.cs \
421         sleep.cs \
422         bug-27147.cs    \
423         bug-30085.cs    \
424         bug-17537.cs    \
425         pinvoke_ppcc.cs \
426         pinvoke_ppcs.cs \
427         pinvoke_ppci.cs \
428         pinvoke_ppcf.cs \
429         pinvoke_ppcd.cs
430
431 TEST_CS_SRC_DIST=       \
432         $(BASE_TEST_CS_SRC)     \
433         async-exc-compilation.cs \
434         filter-stack.cs \
435         finally_guard.cs \
436         finally_block_ending_in_dead_bb.cs
437
438 TEST_CS_SRC_GEN = \
439         runtime-invoke.gen.cs \
440         imt_big_iface_test.cs
441
442 if AMD64
443 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs finally_block_ending_in_dead_bb.cs
444 # #651684
445 PLATFORM_DISABLED_TESTS = finally_guard.exe
446 else
447 if X86
448 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs finally_block_ending_in_dead_bb.cs
449 else
450 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
451 endif
452 endif
453
454 if IA64
455 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
456 # bug #319249
457 PLATFORM_DISABLED_TESTS=exception17.exe
458 PLATFORM_DISABLED_TESTS+=winx64structs.exe
459 endif
460
461 if X86
462
463 if HOST_WIN32
464 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe finally_block_ending_in_dead_bb.exe \
465         bug-18026.exe monitor.exe threadpool-exceptions5.exe
466 endif
467
468 endif
469
470 if POWERPC
471 # bug #71274
472 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
473 endif
474
475 if POWERPC64
476 # FIXME: These tests hang/fail for unknown reasons
477 PLATFORM_DISABLED_TESTS=monitor.exe threadpool-exceptions5.exe
478 endif
479
480 if ARM
481 PLATFORM_DISABLED_TESTS=filter-stack.exe
482 endif
483
484 if MIPS
485 # monitor.exe is racy
486 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
487 endif
488
489 if S390X
490 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
491 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
492 endif
493
494 if NACL_CODEGEN
495 # Tests that use Thread.Abort()
496 PLATFORM_DISABLED_TESTS= abort-stress-1.exe \
497                          abort-stress-2.exe \
498                          abort-stress-3.exe \
499                          appdomain-thread-abort.exe \
500                          async-exc-compilation.exe \
501                          bug-561239.exe \
502                          bug-70561.exe \
503                          finalizer-abort.exe \
504                          finally_guard.exe \
505                          finally_block_ending_in_dead_bb.exe \
506                          main-returns-abort-resetabort.exe \
507                          main-returns-background-abort-resetabort.exe \
508                          thread6.exe \
509                          threadpool-exceptions5.exe \
510                          threadpool-exceptions6.exe
511
512 # Tests that rely on AppDomain.Unload
513 PLATFORM_DISABLED_TESTS+= appdomain-async-invoke.exe \
514                           appdomain-exit.exe \
515                           appdomain-unload-callback.exe \
516                           appdomain-unload.exe \
517                           domain-stress.exe \
518                           generic-unloading.2.exe \
519                           monitor.exe \
520                           remoting4.exe \
521                           threadpool-exceptions7.exe \
522                           xdomain-threads.exe
523
524 # pinvoke2 attaches a thread to the runtime, but
525 # doesn't 'unattach' it and it hangs in GC on exit
526 PLATFORM_DISABLED_TESTS+= pinvoke2.exe
527
528 # Tests that currently hang waiting for non-main threads
529 # to exit in NaCl, need to investigate.  Most are AppDomain
530 # creation and Delegate tests.
531 PLATFORM_DISABLED_TESTS+= appdomain1.exe \
532                           delegate9.exe \
533                           marshal-valuetypes.exe \
534                           cross-domain.exe \
535                           stackframes-async.2.exe \
536                           generic-marshalbyref.2.exe \
537                           generic-xdomain.2.exe \
538                           bug-415577.exe
539
540 # Tests that fail trying to write files (appdomain create mostly)
541 PLATFORM_DISABLED_TESTS+= bug-335131.2.exe \
542                           bug-349190.2.exe \
543                           bug-80307.exe \
544                           bug-462592.exe
545
546 # FIXME: don't know why delegate2.exe fails, it shouldn't
547 PLATFORM_DISABLED_TESTS+= delegate2.exe
548
549 # These tests newly fail with the latest revision. pinvoke3 fails because
550 # of a thread attach, the others have not been investigated.  TODO revisit.
551 PLATFORM_DISABLED_TESTS+= pinvoke3.exe \
552                           async_read.exe \
553                           async-with-cb-throws.exe \
554                           appdomain-unload-doesnot-raise-pending-events.exe \
555                           gsharing-valuetype-layout.exe
556
557 if X86
558 # FIXME: There are problems with async callbacks and results on NaCl 32-bit
559 PLATFORM_DISABLED_TESTS+= delegate1.exe \
560                           delegate3.exe \
561                           delegate5.exe \
562                           delegate8.exe \
563                           threadpool.exe \
564                           threadpool1.exe \
565                           threadpool-exceptions3.exe \
566                           bug-323114.exe \
567                           delegate-exit.exe \
568                           bug-80392.2.exe
569
570 # FIXME: These tests hang/fail for unknown reasons, deal with exiting
571 PLATFORM_DISABLED_TESTS+= main-returns-background-resetabort.exe \
572                           main-returns-background.exe \
573                           main-returns-background-change.exe
574 endif
575
576 endif
577
578 # The two finalizer tests only work under sgen
579 # gc-altstack.exe fails under boehm because it has no support for altstack
580 # bug-459094.exe creates an extremely deep directory tree
581 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
582 # reverted.
583 # bug-Xamarin-5278.exe got broken by 5d26590e79da139a284459299aee95c25f4cd835
584 DISABLED_TESTS=                 \
585         delegate-async-exception.exe    \
586         bug-348522.2.exe        \
587         bug-459094.exe \
588         delegate-invoke.exe \
589         bug-Xamarin-5278.exe \
590         $(PLATFORM_DISABLED_TESTS) \
591         $(EXTRA_DISABLED_TESTS)
592
593 DISABLED_TESTS_WRENCH=  \
594         $(DISABLED_TESTS)       \
595         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
596         main-returns-background-resetabort.exe \
597         main-returns-background-abort-resetabort.exe    \
598         thread6.exe     \
599         assemblyresolve_event3.exe \
600         delegate2.exe   \
601         finally_guard.exe \
602         gc-altstack.exe \
603         generic-xdomain.2.exe
604
605 AOT_DISABLED_TESTS=constraints-load.exe
606
607 # These only compile with MS CSC
608 TEST_CSC_SRC=                   \
609         vararg.cs
610
611 TEST_IL_SRC=                    \
612         field-access.il         \
613         method-access.il        \
614         ldftn-access.il         \
615         cpblkTest.il            \
616         vbinterface.il          \
617         calliTest.il            \
618         calliGenericTest.il             \
619         ckfiniteTest.il         \
620         fault-handler.il                \
621         locallocTest.il         \
622         initblkTest.il          \
623         qt-instance.il          \
624         vararg.il               \
625         bug-29859.il            \
626         bug-78549.il            \
627         static-fields-nonconst.il       \
628         reload-at-bb-end.il     \
629         test-enum-indstoreil.il \
630         filter-bug.il           \
631         even-odd.il             \
632         bug-82022.il    \
633         vt-sync-method.il       \
634         enum_types.il   \
635         invalid-token.il        \
636         call_missing_method.il  \
637         call_missing_class.il   \
638         ldfld_missing_field.il  \
639         ldfld_missing_class.il  \
640         find-method.2.il        \
641         bug-79215.2.il  \
642         bug-79956.2.il  \
643         bug-327438.2.il \
644         bug-387274.2.il \
645         bug-426309.2.il \
646         ldtoken_with_byref_typespec.2.il \
647         resolve_method_bug.2.il \
648         resolve_field_bug.2.il \
649         resolve_type_bug.2.il   \
650         generics-sharing-other-exc.2.il \
651         generic-ldobj.2.il      \
652         generic-mkrefany.2.il   \
653         generic-refanyval.2.il  \
654         generic-ldtoken.2.il    \
655         generic-ldtoken-method.2.il     \
656         generic-ldtoken-field.2.il      \
657         generic-tailcall.2.il   \
658         generic-tailcall2.2.il  \
659         generic-array-exc.2.il  \
660         generic-valuetype-newobj2.2.il  \
661         generic-valuetype-newobj.2.il   \
662         generic-constrained.2.il        \
663         generic-type-load-exception.2.il        \
664         bug-81466.il    \
665         bug457574.il    \
666         bug445361.il    \
667         bug-463303.il   \
668         bug469742.2.il  \
669         bug-528055.il   \
670         constraints-load.il     \
671         array_load_exception.il \
672         bug-481403.il   \
673         interface-with-static-method.il \
674         bug-515884.il   \
675         bug-633291.il   \
676         delegate-with-null-target.il    \
677         bug-318677.il   \
678         gsharing-valuetype-layout.il    \
679         invalid_generic_instantiation.il
680
681
682 # pre-requisite test sources: files that are not test themselves
683 # but that need to be compiled
684 PREREQ_IL_SRC=event-il.il module-cctor.il
685 PREREQ_CS_SRC=
686 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
687 PREREQ_CS_DLL_SRC=
688
689 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
690 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
691 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
692 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
693 TESTBS=$(BENCHSRC:.cs=.exe)
694 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
695
696 EXTRA_DIST=test-driver test-runner.cs $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
697         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
698
699 %.exe: %.il
700         $(ILASM) -out:$@ $<
701
702 %.exe: %.cs TestDriver.dll
703         $(MCS) -r:TestDriver.dll -out:$@ $<
704
705 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
706 if POWERPC
707 test_platform:
708 else
709 # Can't use mkbundle on win32 since there is no static build there
710 # Can't run test-unhandled-exception on Windows because of all the debug popups...
711 if HOST_WIN32
712 test_platform:
713 else
714 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
715 #test_platform: testbundle test-iomap-regression
716 test_platform:  test-iomap-regression
717 endif
718 endif
719
720 if X86
721 if HOST_WIN32
722 else
723 test_platform: test-eglib-remap
724 endif
725 endif
726
727 # Target to precompile the test executables
728 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
729
730 #
731 # Test that no symbols are missed in eglib-remap.h
732 #
733 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file\|g_Ctoc\'
734 if NACL_CODEGEN
735 test-eglib-remap:
736 else
737 test-eglib-remap:
738         @echo "Testing eglib remap..."
739         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
740 endif
741
742 #
743 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
744 # code that checks that the table is properly sorted
745 #
746 if NACL_CODEGEN
747 test-messages:
748 else
749 if HOST_WIN32
750 test-messages:
751 else
752 test-messages: w32message.exe
753         > test_messages.zero
754         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe > w32message.allout 2>&1 && cmp test_messages.zero w32message.allout
755 endif
756 endif
757
758 test-env-options:
759         MONO_ENV_OPTIONS="--version" $(RUNTIME) array-init.exe | grep -q Architecture:
760
761 if AMD64
762 test-sgen : sgen-tests
763 else
764 if X86
765 if HOST_WIN32
766 test-sgen :
767 else
768 test-sgen : sgen-tests
769 endif
770 else
771 if ARM
772 test-sgen : sgen-tests
773 else
774 if S390X
775 test-sgen : sgen-regular-tests
776 endif
777 endif
778 endif
779 endif
780
781 # Precompile the test assemblies in parallel
782 compile-tests:
783         $(MAKE) -j4 $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
784
785 # Remove empty .stdout and .stderr files for wrench
786 rm-empty-logs:
787         @echo "Removing empty logs..."
788         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
789
790 assemblyresolve/test/asm.dll:
791         $(MAKE) -C assemblyresolve prereq
792
793 TestDriver.dll:
794         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
795
796 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
797         @failed=0; \
798         passed=0; \
799         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
800         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
801         for i in $(TESTSI_CS); do       \
802                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
803                 then \
804                         passed=`expr $${passed} + 1`; \
805                 else \
806                         if [ $$? = 2 ]; then break; fi; \
807                         failed=`expr $${failed} + 1`; \
808                 fi \
809         done; \
810         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
811
812 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
813         @failed=0; \
814         passed=0; \
815         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
816         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
817         for i in $(TESTSI_IL); do       \
818                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
819                 then \
820                         passed=`expr $${passed} + 1`; \
821                 else \
822                         if [ $$? = 2 ]; then break; fi; \
823                         failed=`expr $${failed} + 1`; \
824                 fi \
825         done; \
826         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
827
828 testb: $(TEST_PROG) $(TESTBS)
829         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
830         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
831         for i in $(TESTBS); do  \
832                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS);  \
833         done
834
835 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
836         @failed=0; \
837         passed=0; \
838         failed_tests="";\
839         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
840         if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
841         rm -f testlist testlist.sorted; \
842         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do echo $${i} >> testlist; sort testlist > testlist.sorted; done; \
843         for i in `cat testlist.sorted`; do \
844                 rm -f $${i}.so; \
845                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
846                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i "$${disabled_tests}" "$${dump_action}" $(RUNTIME_ARGS); \
847                 then \
848                         passed=`expr $${passed} + 1`; \
849                 else \
850                         if [ $$? = 2 ]; then break; fi; \
851                         failed=`expr $${failed} + 1`; \
852                         failed_tests="$${failed_tests} $$i"; \
853                 fi \
854         done; \
855         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
856         rm -f testlist testlist.sorted; \
857         if [ $${failed} != 0 ]; then \
858           echo -e "\nFailed tests:\n"; \
859           for i in $${failed_tests}; do \
860             echo $${i}; \
861             if [ "x$$V" = "x1" ]; then \
862               cat $${i}.stdout; \
863               cat $${i}.stderr; \
864             fi; \
865           done; \
866           exit 1; \
867         fi
868
869 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
870         @if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
871         $(RUNTIME) ./test-runner.exe -j a --testsuite-name "runtime" --disabled "$${disabled_tests}" $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
872
873 runtest-managed-serial: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
874         @if [ "x$$CI" = "x1" ]; then disabled_tests="$(DISABLED_TESTS_WRENCH)"; else disabled_tests="$(DISABLED_TESTS)"; fi; \
875         $(RUNTIME) ./test-runner.exe -j 1 --testsuite-name "runtime" --disabled "$${disabled_tests}" $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
876
877 testjit:
878         @if test x$(M) != x0; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
879
880 testaot:
881         @$(MAKE) AOT=1 runtest
882
883 testtrace:
884         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
885
886 testinterp:
887         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
888
889 testjitspeed: $(JITTEST_PROG) $(TESTBS)
890         for i in $(TESTBS); do  \
891                 echo $$i;       \
892                 time $(JITTEST_PROG) $$i;       \
893         done
894
895 test-iomap-regression: exists.cs
896         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
897         @echo "Testing exists.exe..."
898         @MONO_IOMAP=all $(RUNTIME) exists.exe
899
900 stresstest: $(STRESS_TESTS)
901         @failed=0; \
902         passed=0; \
903         failed_tests="";\
904         for i in $(STRESS_TESTS); do    \
905                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
906                 then \
907                         passed=`expr $${passed} + 1`; \
908                 else \
909                         if [ $$? = 2 ]; then break; fi; \
910                         failed=`expr $${failed} + 1`; \
911                         failed_tests="$${failed_tests} $$i"; \
912                 fi \
913         done; \
914         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
915         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
916           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
917
918 testbundle: console.exe
919         @echo "Testing mkbundle..."
920         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
921         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) ./a.out >> mkbundle.stdout
922         @- rm -rf a.out
923
924 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
925 test-type-load: TestDriver.dll
926         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
927         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
928         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
929         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
930         @echo "Testing load-exception.exe..."
931         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
932
933 EXTRA_DIST += custom-attr-errors.cs custom-attr-errors-lib.cs
934 test-cattr-type-load: TestDriver.dll custom-attr-errors.cs custom-attr-errors-lib.cs
935         $(MCS) -D:WITH_MEMBERS /t:library $(srcdir)/custom-attr-errors-lib.cs
936         $(MCS) -r:TestDriver.dll -r:custom-attr-errors-lib.dll  $(srcdir)/custom-attr-errors.cs
937         $(MCS) /t:library $(srcdir)/custom-attr-errors-lib.cs
938         @echo "Testing custom-attribute-load-exceptions.exe..."
939         @$(RUNTIME) custom-attr-errors.exe > custom-attr-errors.exe.stdout 2> custom-attr-errors.exe.stderr
940
941 EXTRA_DIST += reflection-load-with-context-lib.cs reflection-load-with-context-second-lib.cs reflection-load-with-context.cs
942 test-reflection-load-with-context: reflection-load-with-context-lib.cs reflection-load-with-context-second-lib.cs reflection-load-with-context.exe
943         rm -rf reflection-load-dir
944         mkdir reflection-load-dir
945         $(MCS) /t:library $(srcdir)/reflection-load-with-context-second-lib.cs -out:reflection-load-dir/reflection-load-with-context-second-lib.dll
946         $(MCS) /t:library -r:reflection-load-dir/reflection-load-with-context-second-lib.dll $(srcdir)/reflection-load-with-context-lib.cs -out:reflection-load-dir/reflection-load-with-context-lib.dll
947         @echo "Testing reflection-load-with-context.cs.exe..."
948         @$(RUNTIME) reflection-load-with-context.exe > reflection-load-with-context.exe.stdout 2> reflection-load-with-context.exe.stderr
949
950
951 EXTRA_DIST += debug-casts.cs
952 # This depends on TLS, so its not ran by default
953 debug-casts:
954         @$(MCS) -r:TestDriver.dll $(srcdir)/debug-casts.cs
955         @$(RUNTIME) --debug=casts debug-casts.exe
956
957 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs sgen-domain-unload-2.cs sgen-suspend.cs sgen-new-threads-dont-join-stw.cs sgen-bridge-xref.cs bug-17590.cs sgen-toggleref.cs
958
959
960 #those are actually configurations, eg plain_sgen-descriptors.exe
961 #DISABLE_SGEN_TESTS =
962
963 SGEN_TESTS =    \
964         finalizer-wait.exe      \
965         critical-finalizers.exe \
966         sgen-descriptors.exe    \
967         sgen-gshared-vtype.exe  \
968         sgen-domain-unload.exe  \
969         sgen-domain-unload-2.exe        \
970         sgen-weakref-stress.exe \
971         sgen-cementing-stress.exe       \
972         sgen-case-23400.exe     \
973         sgen-new-threads-dont-join-stw.exe      \
974         gc-graystack-stress.exe \
975         bug-17590.exe
976
977 SGEN_CONFIGURATIONS =   \
978         "|plain"        \
979         "major=marksweep-conc|ms-conc"  \
980         "major=marksweep-conc,minor=split|ms-conc-split"        \
981         "minor=split|ms-split"  \
982         "minor=split,alloc-ratio=95|ms-split-95"        \
983         "|plain-clear-at-gc|clear-at-gc"        \
984         "major=marksweep-conc|ms-conc-clear-at-gc|clear-at-gc"  \
985         "minor=split|ms-split-clear-at-gc|clear-at-gc"
986
987
988 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
989 SGEN_BRIDGE_CONFIGURATIONS =    \
990         "|plain"        \
991         ",major=marksweep-conc|ms-conc" \
992         "minor=split|ms-split"  \
993         "bridge-implementation=new|plain-new-bridge"    \
994         "bridge-implementation=new,major=marksweep-conc|ms-conc-new-bridge"     \
995         "bridge-implementation=new,minor=split|ms-split-new-bridge"     \
996         "bridge-implementation=tarjan|plain-tarjan-bridge"      \
997         "bridge-implementation=tarjan,minor=split|ms-split-tarjan-bridge"
998
999 sgen-regular-tests: $(SGEN_TESTS)
1000         @failed=0; \
1001         passed=0; \
1002         failed_tests="";\
1003         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1004         for test in $+; do      \
1005                 echo "...$$test";       \
1006                 for conf in $(SGEN_CONFIGURATIONS); do  \
1007                         name=`echo $$conf | cut -d\| -f 2`;     \
1008                         params=`echo $$conf | cut -d\| -f 1`;   \
1009                         debug_opt=`echo $$conf | cut -d\| -f 3`;        \
1010                         test_name="$${test}|$${name}";  \
1011                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" MONO_GC_DEBUG="$$debug_opt" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);     \
1012                         then \
1013                                 passed=`expr $${passed} + 1`; \
1014                         else \
1015                                 if [ $$? = 2 ]; then break; fi; \
1016                                 failed=`expr $${failed} + 1`; \
1017                                 failed_tests="$${failed_tests} $$test_name"; \
1018                         fi \
1019                 done    \
1020         done;   \
1021         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1022         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1023           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1024
1025 sgen-bridge-tests1: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
1026         @failed=0; \
1027         passed=0; \
1028         failed_tests="";\
1029         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1030         for test in $+; do      \
1031                 echo "...$$test";       \
1032                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
1033                         name=`echo $$conf | cut -d\| -f 2`;     \
1034                         params=`echo $$conf | cut -d\| -f 1`;   \
1035                         test_name="$${test}|$${name}";  \
1036                         if MONO_GC_DEBUG="bridge=Bridge" MONO_GC_PARAMS="$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS); \
1037                         then \
1038                                 passed=`expr $${passed} + 1`; \
1039                         else \
1040                                 if [ $$? = 2 ]; then break; fi; \
1041                                 failed=`expr $${failed} + 1`; \
1042                                 failed_tests="$${failed_tests} $$test_name"; \
1043                         fi \
1044                 done    \
1045         done;   \
1046         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1047         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1048           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1049
1050 sgen-bridge-tests2: sgen-bridge-xref.exe
1051         @failed=0; \
1052         passed=0; \
1053         failed_tests="";\
1054         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1055         for test in $+; do      \
1056                 echo "...$$test";       \
1057                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
1058                         name=`echo $$conf | cut -d\| -f 2`;     \
1059                         params=`echo $$conf | cut -d\| -f 1`;   \
1060                         test_name="$${test}|$${name}";  \
1061                         if MONO_GC_DEBUG="bridge=2Bridge" MONO_GC_PARAMS="$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);        \
1062                         then \
1063                                 passed=`expr $${passed} + 1`; \
1064                         else \
1065                                 if [ $$? = 2 ]; then break; fi; \
1066                                 failed=`expr $${failed} + 1`; \
1067                                 failed_tests="$${failed_tests} $$test_name"; \
1068                         fi \
1069                 done    \
1070         done;   \
1071         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1072         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1073           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1074
1075 sgen-toggleref-tests: sgen-toggleref.exe
1076         @failed=0; \
1077         passed=0; \
1078         failed_tests="";\
1079         if [ "x$$V" = "x1" ]; then dump_action="dump-output"; else dump_action="no-dump"; fi; \
1080         for test in $+; do      \
1081                 echo "...$$test";       \
1082                 for conf in $(SGEN_CONFIGURATIONS); do  \
1083                         name=`echo $$conf | cut -d\| -f 2`;     \
1084                         params=`echo $$conf | cut -d\| -f 1`;   \
1085                         test_name="$${test}|$${name}";  \
1086                         if MONO_GC_PARAMS="toggleref-test,$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" "$${dump_action}" $(RUNTIME_ARGS);  \
1087                         then \
1088                                 passed=`expr $${passed} + 1`; \
1089                         else \
1090                                 if [ $$? = 2 ]; then break; fi; \
1091                                 failed=`expr $${failed} + 1`; \
1092                                 failed_tests="$${failed_tests} $$test_name"; \
1093                         fi \
1094                 done    \
1095         done;   \
1096         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1097         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1098           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1099
1100 sgen-bridge-tests: sgen-bridge-tests1 sgen-bridge-tests2
1101
1102 sgen-tests: sgen-regular-tests sgen-bridge-tests sgen-toggleref-tests
1103
1104 AOT_CONFIGURATIONS=     \
1105         "|regular"      \
1106         "--gc=boehm|boehm"
1107
1108 #LLVM crashes, got to fix it first.
1109 #       "--llvm|llvm"   \
1110 #       "--llvm --gc=boehm|llvm+boehm"
1111
1112
1113 test-aot:
1114         @failed=0; \
1115         passed=0; \
1116         failed_tests="";\
1117         profile=$(DEFAULT_PROFILE);     \
1118         tmpfile=`mktemp -t mono_aot_output` || exit 1;  \
1119         rm -f test-aot-$${name}.stdout test-aot-$${name}.stderr; \
1120         for assembly in $(mcs_topdir)/class/lib/$$profile/*.dll ; do    \
1121                 asm_name=`basename $$assembly`; \
1122                 echo "... $$asm_name";  \
1123                 for conf in $(AOT_CONFIGURATIONS); do   \
1124                         name=`echo $$conf | cut -d\| -f 2`;     \
1125                         params=`echo $$conf | cut -d\| -f 1`;   \
1126                         test_name="$${asm_name}|$${name}";      \
1127                         echo "  $$test_name";   \
1128                         if MONO_PATH=$(mcs_topdir)/class/lib/$$profile $(JITTEST_PROG_RUN) $$params --aot=outfile=$$tmpfile $$assembly >> test-aot-$${name}.stdout 2>> test-aot-$${name}.stderr;        \
1129                         then \
1130                                 passed=`expr $${passed} + 1`; \
1131                         else \
1132                                 failed=`expr $${failed} + 1`; \
1133                                 failed_tests="$${failed_tests} $$test_name"; \
1134                         fi \
1135                 done;   \
1136         done;   \
1137         rm      $$tmpfile;      \
1138         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
1139         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
1140         for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
1141
1142
1143 # Generated tests for runtime invoke
1144 EXTRA_DIST += gen-runtime-invoke.cs
1145 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
1146         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
1147         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
1148
1149 EXTRA_DIST += make-imt-test.cs
1150 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
1151         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
1152         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
1153
1154 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
1155 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
1156         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
1157 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
1158         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
1159
1160 EXTRA_DIST += unhandled-exception-base-configuration.config
1161 EXTRA_DIST += unhandled-exception-legacy-configuration.config
1162 EXTRA_DIST += appdomain-unload.exe.config
1163 EXTRA_DIST += unhandled-exception-test-case.2.cs
1164 EXTRA_DIST += unhandled-exception-test-runner.2.cs
1165 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
1166         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
1167 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
1168         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
1169 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
1170         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
1171 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
1172         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
1173         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
1174         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
1175         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
1176 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
1177         $(MCS) /debug unhandled-exception-test-case.1.cs
1178 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
1179         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
1180 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
1181         $(MCS) /debug unhandled-exception-test-case.2.cs
1182 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
1183         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
1184 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
1185         $(MCS) /debug unhandled-exception-test-runner.2.cs
1186
1187 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
1188         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
1189
1190 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
1191 bug-80307.exe: $(srcdir)/bug-80307.cs
1192         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
1193         cd $(top_builddir)/runtime && $(MAKE) test-support-files
1194
1195 EXTRA_DIST += bug-81673-interface.cs
1196 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
1197         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1198         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
1199         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1200
1201 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
1202 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
1203         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
1204         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
1205         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
1206         rm -f bug-81691-a.dll
1207 bug-81691.exe: bug-81691-b.dll
1208
1209 EXTRA_DIST += bug-81466-lib.il
1210 bug-81466-lib.dll: bug-81466-lib.il
1211         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
1212 bug-81466.exe: bug-81466.il bug-81466-lib.dll
1213         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
1214
1215 EXTRA_DIST += bug-324535-il.il
1216 bug-324535-il.dll : bug-324535-il.il
1217         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
1218 bug-324535.exe : bug-324535.cs bug-324535-il.dll
1219         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
1220
1221 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
1222 custom-modifiers-lib.dll: custom-modifiers-lib.il
1223         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
1224 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
1225         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
1226
1227 EXTRA_DIST += bug-382986-lib.cs
1228 bug-382986-lib.dll: bug-382986-lib.cs
1229         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
1230 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
1231         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
1232
1233 EXTRA_DIST += bug-17537-helper.cs
1234 bug-17537-helper.exe: bug-17537-helper.cs
1235         $(MCS) -out:$@ $(srcdir)/bug-17537-helper.cs
1236         chmod -x $@
1237
1238 bug-17537.exe: bug-17537.cs bug-17537-helper.exe
1239         $(MCS) -out:$@ $(srcdir)/bug-17537.cs
1240
1241 EXTRA_DIST += coreclr-security.cs
1242
1243 coreclr-security.exe : coreclr-security.cs
1244         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
1245
1246 test-coreclr-security : coreclr-security.exe
1247         @echo "Testing coreclr-security.exe..."
1248         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
1249
1250 EXTRA_DIST += generic-unboxing.2.il
1251 generic-unboxing.2.dll : generic-unboxing.2.il
1252         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
1253
1254 EXTRA_DIST += generic-boxing.2.il
1255 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
1256         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
1257
1258 EXTRA_DIST += generic-unbox.2.cs
1259 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
1260         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
1261
1262 EXTRA_DIST += generic-box.2.cs
1263 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
1264         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
1265
1266 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
1267 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
1268         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
1269 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
1270         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
1271
1272 bug-3903.exe: bug-3903.cs
1273         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
1274
1275 gshared: test-generic-sharing
1276
1277 gshared-aot:
1278         @$(MAKE) AOT=1 gshared
1279
1280 GSHARED_TESTS = \
1281                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1282                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1283                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1284                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1285                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1286                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1287                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1288                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1289                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1290                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1291                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1292                 generic-array-exc.2.exe generic-special.2.exe                   \
1293                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1294                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1295                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1296                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1297                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1298                 generic-constrained.2.exe bug-431413.2.exe                      \
1299                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1300                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1301                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1302                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1303                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1304                 bug-479763.2.exe                                \
1305                 generic-type-load-exception.2.exe bug-616463.exe        \
1306                 bug-1147.exe
1307
1308 test-generic-sharing-normal: $(GSHARED_TESTS)
1309         @for fn in $+ ; do      \
1310                 echo "Testing $$fn ...";        \
1311                 $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;      \
1312                 $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;      \
1313                 $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;      \
1314                 $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;       \
1315                 if [ x$(AOT) = x1 ]; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1316         done
1317
1318 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1319         @$(RUNTIME) ./test-runner.exe -j a --testsuite-name "gshared" --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1320
1321 if NACL_CODEGEN
1322 test-generic-sharing:
1323 else
1324 test-generic-sharing:
1325         @if test x$(M) != x0; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1326 endif
1327
1328 EXTRA_DIST += async-exceptions.cs
1329 async-exceptions.exe : async-exceptions.cs
1330         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1331 test-async-exceptions : async-exceptions.exe
1332         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1333         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1334
1335 EXTRA_DIST += modules.cs modules-m1.cs
1336 modules-m1.netmodule: modules-m1.cs
1337         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1338 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1339         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1340
1341 # Useful if mono is compiled with --enable-shared=no
1342 patch-libtool:
1343         cp "../../libtool" .
1344         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1345         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1346         touch libtest.c
1347
1348
1349 if NACL_CODEGEN
1350 test-process-exit:
1351 else
1352 EXTRA_DIST += threadpool-in-processexit.cs threadpool-in-processexit.exe.stdout.expected
1353 test-process-exit:
1354         @$(MCS) $(srcdir)/threadpool-in-processexit.cs -out:threadpool-in-processexit.exe
1355         @echo "Testing threadpool-in-processexit.exe..."
1356         @$(RUNTIME) threadpool-in-processexit.exe > threadpool-in-processexit.exe.stdout
1357         @diff -w threadpool-in-processexit.exe.stdout $(srcdir)/threadpool-in-processexit.exe.stdout.expected
1358 endif
1359
1360 OOM_TESTS =     \
1361         gc-oom-handling.exe     \
1362         gc-oom-handling2.exe
1363
1364
1365 test-oom: $(OOM_TESTS)
1366         @for fn in $+ ; do      \
1367                 echo "Testing $$fn ...";        \
1368                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1369                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1370         done
1371
1372 if HOST_WIN32
1373 test-unhandled-exception-2:
1374 else
1375 test-unhandled-exception-2: test-unhandled-exception-2-1 test-unhandled-exception-2-2 test-unhandled-exception-2-3 test-unhandled-exception-2-4 \
1376                  test-unhandled-exception-2-5 test-unhandled-exception-2-6 test-unhandled-exception-2-7 test-unhandled-exception-2-8
1377
1378 test-unhandled-exception-2-1: unhandled-exception-1.exe test-runner.exe
1379         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 1 $<
1380 test-unhandled-exception-2-2: unhandled-exception-2.exe test-runner.exe
1381         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 0 $<
1382 test-unhandled-exception-2-3: unhandled-exception-3.exe test-runner.exe
1383         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 255 $<
1384 test-unhandled-exception-2-4: unhandled-exception-4.exe test-runner.exe
1385         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 0 $<
1386 test-unhandled-exception-2-5: unhandled-exception-5.exe test-runner.exe
1387         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 255 $<
1388 test-unhandled-exception-2-6: unhandled-exception-6.exe test-runner.exe
1389         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 0 $<
1390 test-unhandled-exception-2-7: unhandled-exception-7.exe test-runner.exe
1391         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 0 $<
1392 test-unhandled-exception-2-8: unhandled-exception-8.exe test-runner.exe
1393         @$(RUNTIME) ./test-runner.exe --testsuite-name $@ --expected-exit-code 3 $<
1394 endif
1395
1396 EXTRA_DIST += appdomain-loader.cs appdomain-tester.cs
1397 test-appdomain-unload: appdomain-loader.exe appdomain-tester.exe
1398         $(RUNTIME) -O=gshared appdomain-loader.exe > appdomain-loader.exe.1.stdout || exit 1;
1399         $(RUNTIME) appdomain-loader.exe > appdomain-loader.exe.2.stdout || exit 1;
1400         MONO_DEBUG_ASSEMBLY_UNLOAD=1 $(RUNTIME) -O=gshared appdomain-loader.exe > appdomain-loader.exe.3.stdout || exit 1;
1401         MONO_DEBUG_ASSEMBLY_UNLOAD=1 $(RUNTIME) appdomain-loader.exe > appdomain-loader.exe.4.stdout || exit 1;
1402
1403 coreclr-gcstress:
1404         $(MAKE) -C $(mono_build_root)/acceptance-tests coreclr-gcstress
1405
1406 noinst_LTLIBRARIES = libtest.la
1407
1408 AM_CPPFLAGS = $(GLIB_CFLAGS)
1409
1410 if HOST_WIN32
1411 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1412 # This shows up when compiling mono_test_marshal_delegate ()
1413 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1414 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1415 # can't find them. So we use --kill-at to remove the @ suffix as well.
1416 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1417 else
1418 libtest_la_LDFLAGS = -rpath `pwd`
1419 endif
1420 libtest_la_SOURCES = libtest.c
1421 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1422
1423 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat